<template>
	<div class="flex-col md:rounded-lg lg:rounded bg-white px-4 pt-6 pb-8 md:px-6 md:pt-6 lg:px-10 lg:py-10 mb-2">
		<div class="flex justify-between items-center">
			<div>
				<MkStepProgress
					:step-title="stepTitle"
					:step-number="stepNumber"
					:class-active="stepsCompleted == '2' ? 'active' : ''"
				/>
			</div>
			<div v-if="cancel">
				<a
					ref="cancel_button"
					href="javascript:;"
					role="button"
					:aria-label="stepTitle == 'Shipping' ? `Cancel shipping info` : `Cancel recipient’s info`"
					class="font-primary-font-bold focus:outline-none focus:ring-1 focus:ring-black text-base leading-6 mk-link"
					tabindex="0"
					@click="$emit('cancel-shipping')"
					>Cancel</a
				>
			</div>
		</div>
		<div v-if="stepsCompleted == '2'">
			<MkAddNewAddressTitle
				v-if="AUTHENTICATED"
				tabindex="0"
				role="button"
				class="focus:outline-none focus:ring-1 focus:ring-black lg:mt-8 md:mt-6 mt-8 mb-8 md:mb-0"
				:show-add="showAdd"
				@add-address="addAddress"
			/>
			<ValidationObserver v-if="showAdd" ref="shipping_info_validation_observer">
				<div role="group" aria-label="shipping">
					<MkCheck
						:checked="value['businessprofile']"
						radio-title="This is a business address."
						class="mt-6 md:mt-8 lg:mt-10"
						@change="businessprofile"
					/>
					<MkAddressForm
						id="checkout_shipping_form"
						v-model="shippingInfo"
						:address-data="formData['shippingAddress']"
						:business-address="value['businessprofile']"
					/>
				</div>
				<div v-if="GIFT && !AUTHENTICATED">
					<div class="mb-6 mt-2 md:mt-4 lg:mt-6">
						<p class="font-primary-font-bold mb-2" aria-label="Make it personal"> Make it personal. </p>
						<p> They’ll receive a gift receipt with tracking once the order ships. </p>
					</div>
					<MkInput
						v-model="formData['recipientsEmail']"
						rules="required|email"
						:value="formData['recipientsEmail']"
						class="mb-4"
						variant="outline"
						label="Recipient’s email"
						@input="($value) => (formData['recipientsEmail'] = $value)"
					/>
					<MkInput
						v-model="formData['giftMessage']"
						maxlength="200"
						:value="formData['giftMessage']"
						class="mb-4"
						variant="outline"
						label="Gift message (optional)"
						max-char="200 char."
						@input="($value) => (formData['giftMessage'] = $value)"
					/>
				</div>
				<div class="flex justify-center items-center mt-4 md:mt-8">
					<MkPrimaryButton
						btn-class="min-w-150 py-2 h-10"
						:disabled="disableTrue"
						:loading="addressLoading"
						:button-title="buttonLabel"
						font-size="text-xl"
						@click="saveAddress()"
					/>
				</div>
			</ValidationObserver>
			<div></div>
			<div v-if="showList && AUTHENTICATED">
				<ValidationObserver ref="shipping_validation_observer">
					<div>
						<MkAddressTile
							:recent-shipping="RECENT_SHIPPING"
							:rules="shippingEnabled ? 'required' : ''"
							:contents="CUSTOMER_SHIPPING_ADDRESS"
							:selected-address="selectedAddress"
							@selected="selected"
						/>
					</div>
					<div v-if="GIFT">
						<div class="mb-6 mt-2 md:mt-4 lg:mt-6">
							<p class="font-primary-font-bold mb-2" aria-label="Make it personal"> Make it personal. </p>
							<p> They’ll receive a gift receipt with tracking once the order ships. </p>
						</div>
						<MkInput
							v-model="formData['recipientsEmail']"
							rules="required|email"
							:value="formData['recipientsEmail']"
							class="mb-4"
							variant="outline"
							label="Recipient’s email"
							@input="($value) => (formData['recipientsEmail'] = $value)"
						/>
						<MkInput
							v-model="formData['giftMessage']"
							maxlength="200"
							:value="formData['giftMessage']"
							class="mb-4"
							variant="outline"
							label="Gift message (optional)"
							max-char="200 char."
							@input="($value) => (formData['giftMessage'] = $value)"
						/>
					</div>
					<div class="flex justify-center items-center mt-8 lg:mt-10">
						<MkPrimaryButton
							btn-class="min-w-150 py-2 h-10"
							:disabled="disableButton || MERGE_CART_INITIATED"
							:loading="loading"
							button-title="Save"
							font-size="text-xl"
							@click="SaveAddressToCart()"
						/>
					</div>
				</ValidationObserver>
			</div>
		</div>
	</div>
</template>
<script>
import { ValidationObserver } from 'vee-validate';
import { mapState } from 'vuex';
import MkStepProgress from '~/components/D2C/atoms/MkStepProgress.vue';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';
import MkAddressForm from '~/components/D2C/molecules/MkAddressForm.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkAddNewAddressTitle from '~/components/D2C/atoms/MkAddNewAddressTitle.vue';
import MkAddressTile from '~/components/D2C/atoms/MkAddressTile.vue';
export default {
	name: 'MkCheckoutShipping',
	components: {
		MkStepProgress,
		MkInput,
		MkCheck,
		MkPrimaryButton,
		MkAddressForm,
		MkAddNewAddressTitle,
		MkAddressTile,
		ValidationObserver,
	},
	props: {
		stepsCompleted: {
			type: Number,
			default: 1,
		},
		value: {
			type: Object,
			default: () => {},
		},
		editing: {
			type: Boolean,
			default: false,
		},
		cancel: {
			type: Boolean,
			default: false,
		},
	},
	data() {
		return {
			formData: {
				shippingAddress: {
					country: '',
				},
				recipientsEmail: '',
				giftMessage: '',
			},
			shippingInfo: {},
			cancelUpdate: false,
			loading: false,
			stepNumber: 2,
			showAdd: false,
			selectedAddress: {},
			disableButton: false,
			disableTrue: false,
			showList: true,
			shippingEnabled: true,
			userType: 'registeredUser',
			addressLoading: false,
			previousShippingAddress: {},
		};
	},
	computed: {
		SHIPPING_RESPONSE() {
			return this.$store.state.USER_STORE.SHIPPING_RESPONSE;
		},
		...mapState('USER_STORE', [
			'AUTHENTICATED',
			'CUSTOMERID',
			'SHIPPING_ADDRESSES',
			'CUSTOMER_SHIPPING_ADDRESS',
			'CUSTOMER_CREDIT_CARD_DETAILS',
			'RECENT_SHIPPING',
			'VALID_ADDRESS',
		]),
		...mapState('CART_STORE', ['GIFT', 'GUEST_USER', 'MERGE_CART_INITIATED']),
		...mapState(['isEurope']),
		buttonLabel() {
			if (!this.AUTHENTICATED) {
				return 'Next';
			} else {
				return 'Save address';
			}
		},
		stepTitle() {
			if (this.GIFT) {
				return 'Recipient’s info';
			} else {
				return 'Shipping';
			}
		},
	},
	watch: {
		stepsCompleted() {
			this.getAccount();
		},
		shippingInfo: {
			deep: true,
			handler() {
				this.checkDataFilled();
			},
		},
	},
	mounted() {
		this.getAccount();
		if (this.value) {
			this.previousShippingAddress = {
				...this.value.addressData,
				isBusiness: this.value.addressData?.isBusiness ?? false,
			};
			this.selectedAddress = this.value.addressData;
			this.shippingInfo = this.value.addressData;
			this.formData.shippingAddress = this.value.addressData;
			this.formData.recipientsEmail = this.value.recipientsEmail;
			this.formData.giftMessage = this.value.giftMessage;
			if (this.editing) {
				this.formData.shippingAddress = this.value.addressData;
				if (this.AUTHENTICATED && this.CUSTOMER_SHIPPING_ADDRESS.length > 0) {
					this.showAdd = false;
				} else {
					this.showAdd = true;
					this.showList = false;
				}
			}
		}
		this.$root.$utility.elementFocus(this, 'cancel_button');
	},
	methods: {
		async getAccount() {
			if (this.AUTHENTICATED) {
				await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
			}
			if (!this.editing) {
				if (this.CUSTOMER_SHIPPING_ADDRESS.length === 0 || this.GUEST_USER) {
					this.showAdd = true;
					this.showList = false;
					this.disableTrue = true;
				} else {
					this.showAdd = false;
					this.showList = true;
					this.disableTrue = false;
				}
			} else if (this.CUSTOMER_SHIPPING_ADDRESS.length > 0) {
				this.showAdd = false;
				this.showList = true;
				this.disableTrue = false;
			}
		},
		async saveAddress() {
			try {
				this.addressLoading = true;
				this.shippingInfo.streetName = this.shippingInfo.streetAddress1;
				this.shippingInfo.streetNumber = this.shippingInfo.streetAddress2 ? this.shippingInfo.streetAddress2 : '';
				this.shippingInfo.phone = this.shippingInfo.phoneNumber;
				this.shippingInfo.isBusiness = this.value.businessprofile;
				this.shippingInfo.company = this.shippingInfo.companyName;
				this.shippingInfo.region = this.shippingInfo.state;
				const isValidForm = await this.$refs.shipping_info_validation_observer.validate();
				if (this.GUEST_USER) {
					if (isValidForm) {
						this.SaveAddressToCart();
					}
				} else {
					const $data = {
						action: 'ADD_SHIPPING_ADDRESS',
						shippingAddress: this.shippingInfo,
						isDefaultAddress: false,
					};
					if (isValidForm && this.VALID_ADDRESS) {
						this.addressLoading = true;
						if (JSON.stringify($data.shippingAddress) !== JSON.stringify(this.previousShippingAddress)) {
							await this.$store.dispatch('USER_STORE/UPDATE_CUSTOMER_BY_ID', $data);
						}
						this.addressLoading = false;
						this.showAdd = false;
						this.showList = true;
						this.disableButton = false;
						this.formData.shippingAddress = {
							country: 'US',
						};
						await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
					}
				}
				this.addressLoading = false;
			} catch (error) {}
		},
		async SaveAddressToCart() {
			const isValidForm = !this.GUEST_USER ? await this.$refs.shipping_validation_observer.validate() : true;
			const $selectedAddress = Object.assign({}, this.GUEST_USER ? this.shippingInfo : this.selectedAddress);
			$selectedAddress.shippingAddressId = $selectedAddress.id;
			$selectedAddress.streetAddress1 = $selectedAddress.streetName;
			$selectedAddress.phoneNumber = $selectedAddress.phone;
			$selectedAddress.companyName = $selectedAddress.company;
			if ($selectedAddress && isValidForm) {
				this.loading = true;
				const $data = {
					action: 'SET_SHIPPING_ADDRESS',
					shippingAddress: $selectedAddress,
				};
				if (this.GIFT) {
					$data.gift = this.GIFT;
					$data.giftMessage = this.formData.giftMessage;
					$data.recipientsEmail = this.formData.recipientsEmail;
				}
				await this.$store.dispatch('CART_STORE/UPDATE_CART_ACTION', $data);
				await this.$store.dispatch('CHECKOUT_STORE/GET_SHIPPING_METHODS');
				if (this.GIFT) {
					this.updateForm('recipientsEmail', this.formData.recipientsEmail);
					this.updateForm('giftMessage', this.formData.giftMessage);
				}
				this.updateForm('addressData', $selectedAddress);
				this.$emit('completedstep');
				this.loading = false;
				this.addressLoading = false;
			}
		},
		updateForm(fieldName, value) {
			this.$set(this.value, fieldName, value);
			this.$emit('input', this.value);
		},
		businessprofile(value) {
			this.updateForm('businessprofile', !value);
		},
		selected(item) {
			this.selectedAddress = item;
			this.shippingEnabled = false;
		},
		addAddress() {
			this.showAdd = !this.showAdd;
			if (!this.editing) {
				this.disableButton = !this.disableButton;
				this.disableTrue = !this.disableTrue;
			} else {
				this.showList = !this.showList;
			}
			this.formData = {
				shippingAddress: {
					country: '',
				},
				recipientsEmail: '',
				giftMessage: '',
			};
			this.$emit('update-address');
		},
		checkDataFilled() {
			const address = this.shippingInfo;
			if (this.showAdd) {
				if (
					address.streetAddress1 &&
					address.city &&
					address.country &&
					address.firstName &&
					address.lastName &&
					address.phoneNumber &&
					address.postalCode &&
					(this.isEurope ? true : address.state)
				) {
					this.disableTrue = false;
				} else {
					this.disableTrue = true;
				}
			}
		},
	},
};
</script>
